
#include "rep.h"


void report(int gen, POPULATION *p, IPTR  pop)
{ /* report generations stats */
    FILE *fp, *gfp;

    gfp = fopen(p->oGoogu, "a");

    if( (fp = fopen(p->ofile, "a")) == NULL)
    {
        printf("error in opening file %s \n", p->ofile);
        exit(1);
    }
    else
    {
        rawStat(fp, p, pop);
        GooguStat(gfp, p, pop);
        fclose(fp);
        fclose(gfp);
    }
    rawStat(stdout, p, pop);
}

void rawStat(FILE *fp, POPULATION *p, IPTR pop)
{
    fprintf(fp," %3d %10.2lf %10.2lf %10.2lf ", p->gen, p->max, 
            p->avg, p->min);
    fprintf(fp," %3d %10.2lf %3d", p->highestEverGen,  p->highestEverFitness, 
            p->highestEverIndex);
    fprintf(fp," %10.2lf\n", pop[p->maxi].fitness);
}

void GooguStat(FILE *fp, POPULATION *p, IPTR pop)
{
    fprintf(fp," %3d %10.2lf %10.2lf %10.2lf\n", p->gen, p->max, 
            p->avg, p->min);
}
